import QtQuick 1.0
import "./js/Util.js" as Util

XmlListModel {
    source: "content/info.xml"
    query: "/stations/info"

    XmlRole { name: "name"; query: "name/string()" }
    XmlRole { name: "phillogo"; query: "phillogo/string()" }
    XmlRole { name: "description"; query: "description/string()" }
    XmlRole { name: "lrtlogo"; query: "lrtlogo/string()" }
    XmlRole { name: "mrtlogo"; query: "mrtlogo/string()" }
    XmlRole { name: "lrt1Title"; query: "lrt1/title/string()" }
    XmlRole { name: "lrt1Desc"; query: "lrt1/desc/string()" }
    XmlRole { name: "lrt2Title"; query: "lrt2/title/string()" }
    XmlRole { name: "lrt2Desc"; query: "lrt2/desc/string()" }
    XmlRole { name: "mrt3Title"; query: "mrt3/title/string()" }
    XmlRole { name: "mrt3Desc"; query: "mrt3/desc/string()" }

    onStatusChanged: {
        if (status == XmlListModel.Ready) {
            Util.log("BasicInfoViewModel Status: ready")
        } else if (status == XmlListModel.Error) {
            Util.log("BasicInfoViewModel Status: error")
        } else if (status == XmlListModel.Loading) {
            Util.log("BasicInfoViewModel Status: loading")
        }
    }
}
