import QtQuick 1.0
import "./js/Util.js" as Util

Item {
    id: container

    Visual{
        id: visual
    }

    property string fontName : visual.defaultFontFamily
    property int  fontSize : visual.defaultFontSize
    property color  fontColor : visual.defaultFontColor
    property color  fontColorLink : visual.defaultFontColorLink
    property color  fontColorButton : visual.defaultFontColorButton
    property double  margins : visual.margins
    property int  scrollBarWidth : visual.scrollBarWidth

    // Default values, change when using
    width: 360
    height: 640

    Component.onCompleted: {
        Util.log("basicInfoView Loaded")

    }

    BasicInfoModel{
        id: basicInfoModel

        onStatusChanged: {
            if (status == XmlListModel.Ready) {
                //phillogo.source = basicInfoModel.get(0).phillogo
                //description.text = basicInfoModel.get(0).description
                //                name.text = basicInfoModel.get(0).name
                //                lrt1logo.source = basicInfoModel.get(0).lrtlogo
                //                lrt1Title.text = basicInfoModel.get(0).lrt1Title
                //                lrt1Desc.text = basicInfoModel.get(0).lrt1Desc
                //                lrt2logo.source = basicInfoModel.get(0).lrtlogo
                //                lrt2Title.text = basicInfoModel.get(0).lrt2Title
                //                lrt2Desc.text = basicInfoModel.get(0).lrt2Desc
                //                mrt3logo.source = basicInfoModel.get(0).mrtlogo
                //                mrt3Title.text = basicInfoModel.get(0).mrt3Title
                //                mrt3Desc.text = basicInfoModel.get(0).mrt3Desc
                //Util.log("Loaded Data!!!!!" + phillogo.source )
            }
        }
    }

    Image {
        id: bgImg
        source: "./content/MRLbg.jpg"
        width: parent.width
        height: parent.height
        anchors.fill: parent
        anchors.topMargin: 0
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.leftMargin: 0
        anchors.rightMargin: 0
    }
    //    Rectangle{
    //        id: rectangle1
    //        width: parent.width
    //        height: 55
    //        //color: transparent
    //        opacity: 0
    //        anchors.top: bgImg.top
    //        anchors.topMargin: 320
    //anchors.verticalCenter: parent.verticalCenter
    // anchors.horizontalCenter: parent.horizontalCenter
    // Column{
    //id: colButton
    // width: parent.width
    // anchors.horizontalCenter: parent.horizontalCenter
    //   spacing: 10
    Row{
        id: rowId
        anchors.top: bgImg.top
        anchors.topMargin: 450
        spacing: 10
        anchors.horizontalCenter: parent.horizontalCenter
        ImageButton{
            width: 144
            height: 55
            bgImage : "./content/fare.png"
            bgImagePressed : "./content/fareSlected.png"

            onClicked: {
                fareViewId.show();
            }

        }
        ImageButton{
            width: 144
            height: 55
            bgImage : "./content/sched.png"
            bgImagePressed : "./content/schedSelected.png"

            onClicked: {
                schInfo.show();
            }
        }

    }
    //    }

    Row{
        id: rowId2
        anchors.top: rowId.bottom
        anchors.topMargin: 50
        anchors.horizontalCenter: parent.horizontalCenter
    Text{
        id: aboutIstaID
//        anchors.top: rowId.bottom + 100
//        anchors.horizontalCenter: parent.horizontalCenter

//        width: parent.width
//        height:  30
        font.pointSize: 14
        horizontalAlignment: Text.AlignHCenter
        //  verticalAlignment: Text.AlignVCenter
        text:"<a href='http://www.istaphil.com'>About ISTA</a>"

        anchors.rightMargin: 0
        color: "blue"
        textFormat: Text.RichText
        onLinkActivated :{
            Util.log("Click About ISTA")
        }
        MouseArea{
            anchors.fill: parent
            onClicked: {
                Qt.openUrlExternally("http://www.istaphil.com")
            }
        }
    }
    }

    FareInfoView{
        id: fareViewId
        showCancelButton : false

    }

    ScheInfoView{
        id: schInfo
        anchors.left: parent.left
        anchors.leftMargin: 0
        anchors.right: parent.right
        anchors.rightMargin: 0
        showCancelButton : false
    }
    states: [
        State {
            name: "State1"
        }
    ]
}
