import QtQuick 1.0

import QtMobility.location 1.1

Rectangle {
    id: container
    property int maxX: parent.width; property int maxY: parent.height
    property double latitude
    property double longitude
    property string stationName
    property string distance

    width: 200; height: 65
    opacity: 0.7
    border.color: "black"
    border.width: 1
    radius: 5
    gradient: Gradient {
        GradientStop {position: 0.0; color: "grey"}
        GradientStop {position: 1.0; color: "black"}
    }
    MouseArea {
        anchors.fill: parent
        drag.target: parent
        drag.axis: Drag.XandYAxis
        drag.minimumX: -(parent.width * (2/3)); drag.maximumX: parent.maxX - (parent.width/3)
        drag.minimumY: -(parent.height/2); drag.maximumY: parent.maxY - (parent.height/2)
    }

    Column {
        id: locationGrid
        anchors {left: parent.left; leftMargin: 5; top: parent.top; topMargin: 5}
        spacing: 5
//        Text {color: "white"; font.bold: true
//            text: "My location:"; style: Text.Raised; styleColor: "black"
//        }
//        Text {color: "white"; font.bold: true; width: container.width - 5; elide: Text.ElideRight ;font.pointSize: 6; font.family: visual.defaultFontFamily
//            text: "Lat: " + latitude; style: Text.Raised; styleColor: "black"
//        }
//        Text {color: "white"; font.bold: true; width: container.width - 5; elide: Text.ElideRight ;font.pointSize: 6; font.family: visual.defaultFontFamily
//            text: "Lon: " + longitude; style: Text.Raised; styleColor: "black"
//        }
        Text {color: "white"; font.bold: true ;font.pointSize: 14; font.family: visual.defaultFontFamily
            text: "Station: " + stationName ; style: Text.Raised; styleColor: "black"
        }
        Text {color: "white"; font.bold: true ; font.pointSize: 14; font.family: visual.defaultFontFamily
            text: "Distance: " + distance; style: Text.Raised; styleColor: "black"
        }
    }
}
