import QtQuick 1.0
import "./js/Util.js" as Util
import com.nokia.meego 1.0
Item{
    id: container
    property double margins: visual.margins
    property int spacing: visual.spacing
    property int scrollBarWidth: visual.scrollBarWidth
    property int dfontSize:18
    signal stationInfoClicked( string stationId )
    signal stationMapClicked( string stationId )

//    width: 360
//    height: 640
    width: screen.displayHeight
    height: screen.displayWidth

//    AppStateVars{
//        id: appState
//    }

    Visual{
        id: visual
    }

    Component.onCompleted: {
        Util.log("Lrt1InfoView loaded");
    }

    StationsModel{
        id: stationsModel
        railId : "lrt1"
    }

    Component{
        id: listViewDelegate        
        Item{
            id: itemId
            width:container.width
            //width : screen.displayHeight
            height: 80
            anchors.leftMargin: visual.margins
            Rectangle{
                width: parent.width
                height: parent.height                
                color: "white"
                // opacity: 0.2
                anchors.leftMargin: visual.margins                

                Row{
                    spacing: visual.margins
//                    Image{
//                        id : bgImgage
//                        source: "./content/stationName.png"
//                        anchors.top: itemId.top
//                        anchors.bottom: itemId.bottom
//                        anchors.left: itemId.left
//                        anchors.right: itemId.right
//                    }

                    Text{
                        id: stationId
                        text : name
                        font.bold: true
                        font.family: visual.defaultFontFamily
                        font.pointSize: dfontSize
                        //width: 150
                        width: 380
                        anchors.verticalCenter: buttonId.verticalCenter                        
                    }

                    Button{
                        id: buttonId
                        buttonName : name
                        text: "Info"

                        onClicked: {
                            container.stationInfoClicked(buttonId.buttonName)
                            appState.selectedStationId = buttonId.buttonName
                            appState.selectedStationName =  buttonId.buttonName
                            appState.selectedStationDesc = stationDesc
                            appState.currentCaption = name + " Station"

                            appState.currentViewName = "stationInfoView"
//                            appState.selectedStationLat = latitude
//                            appState.selectedStationLong = longitude
                            Util.log("Clicked station : station name = " + buttonId.buttonName)
                        }
                    }
                    Button{
                        id: mapButtonId
                        buttonName : name
                        text: "Map"
                        onClicked: {
                            container.stationInfoClicked(buttonId.buttonName)
                            appState.selectedStationId = name
                            appState.selectedStationName =  name
//                            appState.selectedStationDesc = stationDesc
                            appState.selectedStationLat = latitude
                            appState.selectedStationLong = longitude
                            appState.currentCaption = name
                            appState.currentViewName = "stationMapView"
                            Util.log("appState.currentCaption " + appState.currentCaption )
                           // Util.log("appState.currentCaption = " + appState.selectedStationLong )
                        }
                    }
                }
            }
        }
    }

    ListView{
        id:listView
        model: stationsModel
        delegate: listViewDelegate
        clip: true
        width: parent.width
        //focus: true
       // highlight: Rectangle { color: "lightsteelblue"; radius : 3 }

        anchors {
            top: parent.top
            left: parent.left
            right: parent.right
            bottom: parent.bottom
            topMargin: container.margins
            leftMargin: container.margins
        }
    }
    ScrollBar { scrollArea: listView; width: container.scrollBarWidth; anchors.top: listView.top; anchors.right: listView.right; anchors.bottom: listView.bottom }
}
