import QtQuick 1.0

Item{
    id: container
    property alias buttonText: myText.text
    property color  textColor : "white"
    property bool btnVisible: true
    property bool  active : false

    visible: btnVisible
    width: 100
    height: 60
    signal buttonClicked

    Rectangle {
        id: bgButton
        anchors.fill: parent
        radius: 10        
        opacity: 0.7 ; color: "#939383"

        Text{
            id: myText
            anchors.centerIn: parent
            font.pixelSize: 16
            font.bold: true
            color: textColor
            text:  "Click Me!"
        }

        MouseArea{
            id: mouseArea
            anchors.fill: parent
            onClicked: {
                container.buttonClicked();
            }
        }

        states: [
            State {
                name: 'pressed'; when: mouseArea.pressed
                PropertyChanges { target: bgButton; opacity: 1 }
                PropertyChanges { target: myText; color : "red" }
            },
            State {
                name: 'active'; when: container.active
                PropertyChanges { target: myText; color: "blue"; }
            }
        ]
    }
}
