import QtQuick 1.0
import QtMobility.location 1.1
import "./js/Util.js" as Util


Item{
    id: mapPannel
//    width: 360
//    height: 640
    width: screen.displayHeight
    height: screen.displayWidth

    Component.onCompleted: {
        Util.log("Lat =" + appState.myLocationLat + "  Long=" + appState.myLocationLong)
    }

    Coordinate{
        id: mapCenter
        latitude: appState.myLocationLat
        longitude: appState.myLocationLong
    }

    Map{
        id: mapView

        plugin: Plugin{ name:"nokia"}

        size.width: parent.width
        size.height: parent.height
        zoomLevel: 13
        center: mapCenter

//        property double  myLocationLat
//        property double  myLocationLong
//        property double  stationLocationLat
//        property double  stationLocationLong

        MapImage{
            id: stationImg
            coordinate.latitude:  appState.stationLocationLat
            coordinate.longitude: appState.stationLocationLong
            source: "./content/star.png"
            offset.x: -15
            offset.y: -15
            //zValue: 7
            // selected: true
        }

        MapImage{
            id: myLocationImg
            coordinate: mapCenter
            source: "./content/myLocation.png"
            offset.x: -15
            offset.y: -15
           // zValue: 7
        }

        MapPolyline{
            id: lineRoad
            visible: true
            //zValue: 7
            path:[
                Coordinate {
                    latitude: appState.stationLocationLat
                    longitude:  appState.stationLocationLong
                },
                Coordinate {
                    latitude: appState.myLocationLat
                    longitude: appState.myLocationLong
                }
            ]
        }
    }

    MouseArea{
        anchors.fill : parent

        property bool mouseDown : false
        property int lastX : -1
        property int lastY : -1

        hoverEnabled : true

        onClicked: {

        }

        onPressed : {
            mouseDown = true
            lastX = mouse.x
            lastY = mouse.y

        }
        onReleased : {
            mouseDown = false
            lastX = -1
            lastY = -1
        }
        onPositionChanged: {
            if (mouseDown) {
                var dx = mouse.x - lastX
                var dy = mouse.y - lastY
                mapView.pan(-dx, -dy)
                lastX = mouse.x
                lastY = mouse.y
            }
        }
        onDoubleClicked: {
            mapView.center = mapView.toCoordinate(Qt.point(mouse.x, mouse.y))
            mapView.zoomLevel += 1
        }
    }
}
