import QtQuick 1.0
import QtMobility.location 1.2
import "./js/Util.js" as Util

Item{
    id: container
//    width: 360
//    height: 640
    width: screen.displayHeight
    height: screen.displayWidth
    focus: true
    property bool  chekFlag: false
    property string  nearStrtionName
    property string  strDistance


    WaitIndicator
    {
        id: waitIndicator
        // Always define the size for the WaitIndicator.
        anchors.fill: parent

        // Start showing the WaitIndicator immediately.
        // Otherwise it'll wait for one second before starting the indicator.
        delay: 0

        // Make sure it's on top of everything, so that the
        // Fader will capture key clicks
        z: 120
        waitMessage : "Checking nearest station"
        // In real application, the WaitIndicator could be bound to
        // some "loading" appState variable etc.
        show :true // container.loading
    }

    Coordinate{
        id: startPt
    }
    Coordinate{
        id: endPt
    }

    NearMeModel{
        id: nearMeModel
        onStatusChanged: {
            if (status == XmlListModel.Ready) {
                Util.log("Total Stations = " +  nearMeModel.count)
                container.chekFlag = true
               // checkingNearStation(nearMeModel)
            }
        }
    }

    function checkingNearStation( nearMeModel )
    {
        var distance = new Array();
        var min = 999999999999999.0 ;
        var indexPoint = 0;
        var rtnValue = 0.0;
        for( var i = 0 ;  i < nearMeModel.count ; i ++ )
        {
            //            Util.log(" Name =" + nearMeModel.get(i).name );
            rtnValue = Util.distance(myPositionSource.position.coordinate.latitude,myPositionSource.position.coordinate.longitude ,nearMeModel.get(i).latitude, nearMeModel.get(i).longitude )
            if(min > rtnValue)
            {
                min = rtnValue ;
                indexPoint = i;
            }

            //            coordi[i].latitude = nearMeModel.get(i).latitude ;
            //            coordi[i].longitude = nearMeModel.get(i).longitude ;

        }
        Util.log("Nearest Station indexPoint = " + indexPoint );
        Util.log("Nearest Station " + nearMeModel.get(indexPoint).name + "  Distance " + min );
        nearStrtionName = nearMeModel.get(indexPoint).name
        strDistance = Util.distanceFormat(min)
        stationPosition.latitude = nearMeModel.get(indexPoint).latitude
        stationPosition.longitude = nearMeModel.get(indexPoint).longitude        
        //       mapView.center = stationPosition
        //        stationImg.coordinate = stationPosition
        //        myLocationImg.coordinate = myPositionSource.position.coordinate

        appState.myLocationLat = myPositionSource.position.coordinate.latitude
        appState.myLocationLong = myPositionSource.position.coordinate.longitude

        appState.stationLocationLat =  stationPosition.latitude
        appState.stationLocationLong = stationPosition.longitude

        Util.log("appState.stationLocationLat" + stationPosition.latitude );
        Util.log("appState.stationLocationLat" + stationPosition.longitude );

//        myPositionSource.stationLat = stationPosition.latitude ;
//        myPositionSource.stationLong = stationPosition.longitude ;
        //mapLoader.source = "MapView.qml"
        waitIndicator.show = false
//        stationImg.coordinate.latitude =stationPosition.latitude
//        stationImg.coordinate.longitude =stationPosition.longitude
        mapLoader.sourceComponent = mapPannel
//        mapView.
        //mapLoader.Loading();
    }

    PositionSource
    {
        id: myPositionSource
        active: true
        updateInterval: 2000
//        property double stationLat  : 0
//        property double stationLong : 0
        onPositionChanged:
        {            
            if( container.chekFlag == true )
            {
                checkingNearStation(nearMeModel)
                container.chekFlag = false
            }
//            else{
//                container.chekFlag = true
//            }

            //Util.log("Position changed: Lat:" +  position.coordinate.latitude + "  Long:" +position.coordinate.longitude )
        }
    }

    Coordinate{
        id: stationPosition
        latitude: 0
        longitude: 0
    }

    Loader{
        id: mapLoader
        //source: ""
        //sourceComponent:
        anchors.fill: parent
        onLoaded: {
            Util.log("Map Loaded")
        }
    }

    //    ListModel{
    //        id: lrtPostion
    //        ListElement{

    //        }
    //    }

    //   ListItem
    Component{
        id: mapPannel

        Item{
            //id: mapPannel
            width: parent.width
            height: parent.height

            Coordinate{
                id: myPosition
                latitude: appState.myLocationLat
                longitude :appState.myLocationLong
            }

            Coordinate{
                id: stationLocate
                latitude:  appState.stationLocationLat
                longitude :appState.stationLocationLong
            }

            Map{
                id: mapView

                plugin: Plugin{ name:"nokia"}

                size.width: parent.width
                size.height: parent.height
                zoomLevel: 15
                center: myPosition //myPositionSource.position.coordinate

                MapImage{
                    id: stationImg
//                    coordinate.latitude:  appState.stationLocationLat
//                    coordinate.longitude: appState.stationLocationLong
//                     coordinate.latitude : stationPosition.latitude
//                     coordinate.longitude: stationPosition.longitude
                    coordinate: stationLocate
                    source: "./content/star.png"
                    offset.x: -15
                    offset.y: -15
                    //zValue: 7
                    // selected: true
                }

                MapCircle {
                        id: myPositionCircle
                        color: "red"
                        radius: 25
                        center: myPositionSource.position.coordinate
               }

//                MapImage{
//                    id: myLocationImg
//                    coordinate:  myPositionSource.position.coordinate
////                    coordinate.latitude: appState.myLocationLat
////                    coordinate.longitude: appState.myLocationLong
//                    source: "./content/myLocation.png"
//                    offset.x: -15
//                    offset.y: -15
//                    //zValue: 7
//                }

                MapPolyline{
                    id: mrt3
                    visible: true
                    border.color: "blue"
                    border.width : 4
                   // zValue: 7
                    Coordinate{
                        latitude: 14.652198
                        longitude :121.032268
                    }
                    Coordinate{
                        latitude: 14.652198
                        longitude :121.032268
                    }
                    Coordinate{
                        latitude: 14.642656
                        longitude :121.038504
                    }
                    Coordinate{
                        latitude: 14.619517
                        longitude :121.051030
                    }
                    Coordinate{
                        latitude: 14.607907
                        longitude :121.056421
                    }
                    Coordinate{
                        latitude: 14.587929
                        longitude :121.056652
                    }
                    Coordinate{
                        latitude: 14.581265
                        longitude :121.053637
                    }
                    Coordinate{
                        latitude: 14.573769
                        longitude :121.048061
                    }
                    Coordinate{
                        latitude: 14.567048
                        longitude :121.045521
                    }
                    Coordinate{
                        latitude: 14.554981
                        longitude :121.034612
                    }
                    Coordinate{
                        latitude: 14.549148
                        longitude :121.027837
                    }
                    Coordinate{
                        latitude: 14.541834
                        longitude :121.019114
                    }
                    Coordinate{
                        latitude: 14.537654
                        longitude :121.001404
                    }
                }

                MapPolyline{
                    id: lrt2
                    visible: true
                    border.color: "purple"
                    border.width : 4
                  //  zValue: 7
                    Coordinate{
                        latitude: 14.60367
                        longitude :120.98332
                    }
                    Coordinate{
                        latitude: 14.600884
                        longitude : 120.992566
                    }
                    Coordinate{
                        latitude: 14.601732
                        longitude : 121.005062
                    }
                    Coordinate{
                        latitude: 14.604076
                        longitude : 121.017087
                    }
                    Coordinate{
                        latitude: 14.610643
                        longitude :121.026134
                    }
                    Coordinate{
                        latitude: 14.613568
                        longitude :121.034070
                    }
                    Coordinate{
                        latitude: 14.618678
                        longitude :121.042680
                    }
                    Coordinate{
                        latitude: 14.622784
                        longitude :121.052690
                    }
                    Coordinate{
                        latitude: 14.628032
                        longitude :121.064712
                    }
                    Coordinate{
                        latitude: 14.630980
                        longitude :121.072820
                    }
                    Coordinate{
                        latitude: 14.621987
                        longitude :121.085979
                    }
                }
                MapPolyline{
                    id: lrt1
                    visible: true
                    border.color: "darkkhaki"
                    border.width : 4
                 //   zValue: 7
                    Coordinate{
                        latitude: 14.534354
                        longitude :120.998341
                    }
                    Coordinate{
                        latitude:14.539012
                        longitude:121.000564
                    }
                    Coordinate{
                        latitude:14.547699
                        longitude:120.998609
                    }
                    Coordinate{
                        latitude:14.554257
                        longitude:120.997112
                    }
                    Coordinate{
                        latitude:14.563481
                        longitude:120.994744
                    }
                    Coordinate{
                        latitude:14.570324
                        longitude:120.991512
                    }
                    Coordinate{
                        latitude:14.576577
                        longitude:120.988009
                    }
                    Coordinate{
                        latitude:14.582665
                        longitude:120.984533
                    }
                    Coordinate{
                        latitude:14.592887
                        longitude:120.981582
                    }
                    Coordinate{
                        latitude:14.599095
                        longitude:120.981343
                    }
                    Coordinate{
                        latitude:14.605348
                        longitude:120.982022
                    }
                    Coordinate{
                        latitude:14.611315
                        longitude:120.982475
                    }
                    Coordinate{
                        latitude:14.616701
                        longitude:120.982709
                    }
                    Coordinate{
                        latitude:14.622662
                        longitude:120.982878
                    }
                    Coordinate{
                        latitude:14.630689
                        longitude:120.981392
                    }
                    Coordinate{
                        latitude:14.644353
                        longitude:120.983545
                    }
                    Coordinate{
                        latitude:14.654256
                        longitude:120.983851
                    }
                    Coordinate{
                        latitude:14.657445
                        longitude:121.003893
                    }
                    Coordinate{
                        latitude:14.657561
                        longitude:121.021163
                    }
                }
            }

            MouseArea{
                anchors.fill : parent

                property bool mouseDown : false
                property int lastX : -1
                property int lastY : -1

                hoverEnabled : true

                onClicked: {

                }

                onPressed : {
                    mouseDown = true
                    lastX = mouse.x
                    lastY = mouse.y

                }
                onReleased : {
                    mouseDown = false
                    lastX = -1
                    lastY = -1
                }
                onPositionChanged: {
                    if (mouseDown) {
                        var dx = mouse.x - lastX
                        var dy = mouse.y - lastY
                        mapView.pan(-dx, -dy)
                        lastX = mouse.x
                        lastY = mouse.y
                    }
                }
                onDoubleClicked: {
                    mapView.center = mapView.toCoordinate(Qt.point(mouse.x, mouse.y))
                    mapView.zoomLevel += 1
                }
            }

            Floater{
                id: dataFloater
                latitude: myPositionSource.position.coordinate.latitude
                longitude: myPositionSource.position.coordinate.longitude
                stationName: nearStrtionName
                distance: strDistance
            }

//            MapButton{
//                id: stationBtn
//                anchors.topMargin: 5
//                anchors.top: parent.top
//                anchors.right: parent.right

//                buttonText: "Distance"
//                onButtonClicked: {
//                    Util.log("Distance Information")
//                }
//            }

            Item{
                id: sliderContainer
                anchors.bottom: parent.bottom
                height: 50
                width: parent.width

                Slider{
                    id: zoomSlider
                    minimum: 1 ; maximum: 18
                    value: 15
                    height: 80
                    anchors.left: parent.left
                    anchors.right: parent.right
                    anchors.bottomMargin: 5; anchors.rightMargin: 20; anchors.leftMargin: 20

                    onValueChanged: {
                        console.log("Zoom slider value changed to: " + value)
                        mapView.zoomLevel = value
                    }

                }
            }
        }


    }
}
