import QtQuick 1.0
import "./js/Util.js" as Util

Item{
    id: container
    property double margins: visual.margins
    property int spacing: visual.spacing
    property int scrollBarWidth: visual.scrollBarWidth
    property int defaultFontSize: visual.defaultFontSize


    signal stationInfoClicked( string stationId )
    signal stationMapClicked( string stationId )

//    width: 360
//    height: 640
    width: screen.displayHeight
    height: screen.displayWidth

    //    AppStateVars{
    //        id: appState
    //    }

    Visual{
        id: visual
    }

    Component.onCompleted: {
        Util.log("Loadind Rail Road loaded : " + appState.selectedRailRoad);

    }


    StationsModel{
        id: stationsModel
        railId : appState.selectedRailRoad
    }

    function bgRailLoadColor()
    {
        if(appState.selectedRailRoad == "lrt1"){
            return "white"
        }else if(appState.selectedRailRoad == "lrt2"){
            return "white"
        }else if(appState.selectedRailRoad == "mrt3"){
            return "white"
        }else{
            return visual.applicationBackgroundColor
        }
    }




    Component{
        id: listViewDelegate
        Item{
            id: itemId
            width:container.width
            height: 40
            anchors.leftMargin: visual.margins
            Image{
                id : bgImgage
                height: 40
                source: "./content/stationName.png"
                anchors.top: itemId.top
                anchors.bottom: itemId.bottom
                anchors.left: itemId.left
                anchors.right: itemId.right
            }
            Rectangle{
                width: parent.width
                height: parent.height
                color: {
                    bgRailLoadColor()
                }
                opacity: 1
                anchors.leftMargin: visual.margins
                Row{
                    spacing: 0

                    Button{
                        id: buttonId
                        buttonName : name
                        text: name
                        btnWidth: 360
                        fontSize : defaultFontSize
                        fontColor : "black"
                        bgImage : "./content/stationName.png"
                        onClicked: {
                            appState.selectedStationId = name
                            appState.selectedStationName =  name
                            appState.selectedStationDesc = stationDesc
                            appState.currentCaption = name
                            //appState.cameFromView = camFromView() ;
                            appState.selectedStationDesc2 = stationDesc2
                            appState.selectedStationLat = latitude
                            appState.selectedStationLong = longitude
                             appState.stationCateId = cateId
                            appState.currentViewName = "stationInfoView"                                                                                  
                            container.stationInfoClicked(buttonId.buttonName)           
                            Util.log("Clicked station : station name = " + buttonId.buttonName)
                             Util.log("appState.Came from View " +appState.cameFromView )
                        }
                    }
                    Button{
                        id: mapButtonId
                        buttonName : name
                        text: "MAP"
                        fontSize :defaultFontSize
                        fontColor : "black"
                        bgImage : "./content/stationMap.png"
                        onClicked: {
                            appState.selectedStationId = name
                            appState.selectedStationName =  name
                            //                            appState.selectedStationDesc = stationDesc
                            appState.selectedStationLat = latitude
                            appState.selectedStationLong = longitude
                            appState.currentCaption = name
                           // appState.cameFromView = camFromView() ;
                            appState.stationCateId = cateId
                            container.stationInfoClicked(buttonId.buttonName)
                            appState.currentViewName = "stationMapView"


                            Util.log("appState.Came from View " +appState.cameFromView )
                            // Util.log("appState.currentCaption = " + appState.selectedStationLong )
                        }
                    }
                }
            }
        }
    }

    ListView{
        id:listView
        model: stationsModel
        delegate: listViewDelegate
        clip: true
        width: parent.width
        focus: true
        highlight: Rectangle { color: "lightsteelblue"; radius : 3 }

        anchors {
            top: parent.top
            left: parent.left
            right: parent.right
            bottom: parent.bottom
            topMargin: container.margins
            leftMargin: container.margins
        }
    }
    ScrollBar { scrollArea: listView; width: container.scrollBarWidth; anchors.top: listView.top; anchors.right: listView.right; anchors.bottom: listView.bottom }
}
