import QtQuick 1.0
import "./js/Util.js" as Util

XmlListModel {
    id: model
    property string  cateId : "144"

    source: "http://www.cgena.com/mobile/landmarks.aspx?cate=" + cateId
    //source: "./content/landmark.xml"

    query: "/LandMarksCollection/Landmark"

    XmlRole { name: "landmarkName"; query: "Name/string()" }
    XmlRole { name: "latitude"; query: "Coordinate/latitude/string()" }
    XmlRole { name: "longitude"; query: "Coordinate/longitude/string()" }
    XmlRole { name: "categoryName"; query: "Category/Name/string()" }
    XmlRole { name: "address"; query: "Address/address/string()" }
    XmlRole { name: "city"; query: "Address/city/string()" }

    onStatusChanged: {
        Util.log(model.source)
        if (status == XmlListModel.Ready) {
            Util.log("StationInfoViewModel Status: ready" + model.get(0).landmarkName )

        } else if (status == XmlListModel.Error) {
            Util.log("StationInfoViewModel Status: error")
        } else if (status == XmlListModel.Loading) {
            Util.log("StationInfoViewModel Status: loading")
        }
    }
}
