import QtQuick 1.0
import QtMobility.location 1.2
import "./js/Util.js" as Util

Item{
    id: container

    //    AppStateVars{
    //        id: appState
    //    }

    property double stationLat : conStrToDbl(appState.selectedStationLat)
    property double stationLong: conStrToDbl(appState.selectedStationLong)

    property double landmarkLat : conStrToDbl(appState.selectedLandmarkLat)
    property double landmarkLong: conStrToDbl(appState.selectedLandmarkLong)

    property string  landMarkImage : appState.landMarkImage
    property bool landMarkOn : appState.landMarkOnOff

    function conStrToDbl(source )
    {
        var rtn = parseFloat(source)
        if( String(rtn) == "NaN")
        {
            rtn = 0.0
        }
      //  console.debug("Return Val : " + rtn)
        return rtn

    }

    Component.onCompleted: {
        Util.log("Map Loaded - landMarkOn =" +  landMarkOn )
        Util.log("Landmark selectedLandMark : " + appState.selectedLandMark );
        myLandMarkImg.visible = landMarkOn
      //  myPositionSource.start()

//        if( landMarkOn ){
//            titleBar.caption = appState.selectedLandMark ;
//        }else{
//            titleBar.caption = appState.currentCaption ;
//        }
    }

    Coordinate{
        id: stationPosition
        latitude: stationLat
        longitude: stationLong
    }    

    Coordinate{
        id: landmarkPosition
        latitude: landmarkLat
        longitude: landmarkLong
    }

//    width: screen.
//    height: 640
    width: screen.displayHeight
    height: screen.displayWidth
    focus: true

    PositionSource
    {
        id: myPositionSource
        active: true
        updateInterval: 2000
        //        position.coordinate.latitude: stationLat
        //        position.coordinate.longitude: stationLong

        onPositionChanged:
        {
           // Util.log("Position changed: Lat:" +  position.coordinate.latitude + "  Long:" +position.coordinate.longitude )
            if( myLocation.active == true)
            {
                 Util.log("Position changed Activated: Lat:" +  position.coordinate.latitude + "  Long:" +position.coordinate.longitude )
                myLocationImg.coordinate = myPositionSource.position.coordinate
                myLocationImg.coordinate = position.coordinate
            }
        }
    }


    Item{
        width: parent.width
        height: parent.height

        Map{
            id: mapView
            z : 1
            connectivityMode  : Map.OnlineMode
            plugin: Plugin{ name:"nokia"}

            size.width: parent.width
            size.height: parent.height
            zoomLevel: 15

            //                    center: Coordinate{
            //                        latitude: stationLat
            //                        longitude: stationLong
            //                    }

            //center: myPositionSource.position.coordinate
            center: stationPosition
            //        MapCircle{
            //            center: Coordinate{
            //                latitude: stationLat + 0.000001
            //                longitude:  stationLong + 0.000001
            //            }
            //            radius: 1000.0
            //        }
            MapImage{
                id: stationImg
                coordinate: stationPosition
                source: "./content/star.png"
                offset.x: -20
                offset.y: -20
                //zValue: 7
               // selected: true
            }

            MapImage{
                id: myLocationImg
                coordinate: myPositionSource.position.coordinate
                visible: true
                source: "./content/myLocation.png"
                offset.x: -20
                offset.y: -20
                //zValue: 7
            }

            MapImage{
                id: myLandMarkImg
                coordinate: landmarkPosition
                visible: true
                source: "./content/pin.png" //landMarkImage
                offset.x: -20
                offset.y: -20
                //zValue: 7
            }

            MapCircle {
                    id: myPositionCircle
                    color: "yellow"
                    radius: 20
                    center: myPositionSource.position.coordinate
           }

            MapPolyline{
                id: mrt3
                visible: true
                border.color: "blue"
                border.width : 4
                //zValue: 7
                Coordinate{
                    latitude: 14.652198
                    longitude :121.032268
                }
                Coordinate{
                    latitude: 14.652198
                    longitude :121.032268
                }
                Coordinate{
                    latitude: 14.642656
                    longitude :121.038504
                }
                Coordinate{
                    latitude: 14.619517
                    longitude :121.051030
                }
                Coordinate{
                    latitude: 14.607907
                    longitude :121.056421
                }
                Coordinate{
                    latitude: 14.587929
                    longitude :121.056652
                }
                Coordinate{
                    latitude: 14.581265
                    longitude :121.053637
                }
                Coordinate{
                    latitude: 14.573769
                    longitude :121.048061
                }
                Coordinate{
                    latitude: 14.567048
                    longitude :121.045521
                }
                Coordinate{
                    latitude: 14.554981
                    longitude :121.034612
                }
                Coordinate{
                    latitude: 14.549148
                    longitude :121.027837
                }
                Coordinate{
                    latitude: 14.541834
                    longitude :121.019114
                }
                Coordinate{
                    latitude: 14.537654
                    longitude :121.001404
                }
            }

            MapPolyline{
                id: lrt2
                visible: true
                border.color: "purple"
                border.width : 4
              //  zValue: 7
                Coordinate{
                    latitude: 14.60367
                    longitude :120.98332
                }
                Coordinate{
                    latitude: 14.600884
                    longitude : 120.992566
                }
                Coordinate{
                    latitude: 14.601732
                    longitude : 121.005062
                }
                Coordinate{
                    latitude: 14.604076
                    longitude : 121.017087
                }
                Coordinate{
                    latitude: 14.610643
                    longitude :121.026134
                }
                Coordinate{
                    latitude: 14.613568
                    longitude :121.034070
                }
                Coordinate{
                    latitude: 14.618678
                    longitude :121.042680
                }
                Coordinate{
                    latitude: 14.622784
                    longitude :121.052690
                }
                Coordinate{
                    latitude: 14.628032
                    longitude :121.064712
                }
                Coordinate{
                    latitude: 14.630980
                    longitude :121.072820
                }
                Coordinate{
                    latitude: 14.621987
                    longitude :121.085979
                }
            }
            MapPolyline{
                id: lrt1
                visible: true
                border.color: "darkkhaki"
                border.width : 4
               // zValue: 7
                Coordinate{
                    latitude: 14.534354
                    longitude :120.998341
                }
                Coordinate{
                    latitude:14.539012
                    longitude:121.000564
                }
                Coordinate{
                    latitude:14.547699
                    longitude:120.998609
                }
                Coordinate{
                    latitude:14.554257
                    longitude:120.997112
                }
                Coordinate{
                    latitude:14.563481
                    longitude:120.994744
                }
                Coordinate{
                    latitude:14.570324
                    longitude:120.991512
                }
                Coordinate{
                    latitude:14.576577
                    longitude:120.988009
                }
                Coordinate{
                    latitude:14.582665
                    longitude:120.984533
                }
                Coordinate{
                    latitude:14.592887
                    longitude:120.981582
                }
                Coordinate{
                    latitude:14.599095
                    longitude:120.981343
                }
                Coordinate{
                    latitude:14.605348
                    longitude:120.982022
                }
                Coordinate{
                    latitude:14.611315
                    longitude:120.982475
                }
                Coordinate{
                    latitude:14.616701
                    longitude:120.982709
                }
                Coordinate{
                    latitude:14.622662
                    longitude:120.982878
                }
                Coordinate{
                    latitude:14.630689
                    longitude:120.981392
                }
                Coordinate{
                    latitude:14.644353
                    longitude:120.983545
                }
                Coordinate{
                    latitude:14.654256
                    longitude:120.983851
                }
                Coordinate{
                    latitude:14.657445
                    longitude:121.003893
                }
                Coordinate{
                    latitude:14.657561
                    longitude:121.021163
                }
            }

        }

        MouseArea{
            anchors.fill : parent

            property bool mouseDown : false
            property int lastX : -1
            property int lastY : -1

            hoverEnabled : true

            onClicked: {
                if(stationImg.selected)
                {
                    Util.log("Station Selected : " + stationImg.selected)
                }
            }

            onPressed : {
                mouseDown = true
                lastX = mouse.x
                lastY = mouse.y
                Util.log("Station Selected : " + stationImg.selected)
            }
            onReleased : {
                mouseDown = false
                lastX = -1
                lastY = -1
            }
            onPositionChanged: {
                if (mouseDown) {
                    var dx = mouse.x - lastX
                    var dy = mouse.y - lastY
                    mapView.pan(-dx, -dy)
                    lastX = mouse.x
                    lastY = mouse.y
                }
            }
            onDoubleClicked: {
                mapView.center = mapView.toCoordinate(Qt.point(mouse.x, mouse.y))
                mapView.zoomLevel += 1
            }
        }
    }


    MapButton{
        id: myLocation
        anchors.topMargin: 10
        anchors.top: parent.top
        anchors.right: parent.right

        buttonText: "My Location"
        onButtonClicked: {            
            if( myLocation.active == true )
            {
                myLocation.active = false
                myLocationImg.visible=false
                distanceBtn.visible = false

            }else{
                if( String(myPositionSource.position.coordinate.latitude) == "NaN")
                {
                    dialog.show();
                    console.log("No Location Coordinate")
                }else{
                    myLocationImg.visible = true
                    myLocation.active = true
                    console.log("Lat =" + myPositionSource.position.coordinate.latitude + "  Long =" + myPositionSource.position.coordinate.longitude )
                    mapView.center = myPositionSource.position.coordinate

                    myLocationImg.coordinate = myPositionSource.position.coordinate

                    distanceBtn.visible = true
                }
            }
        }
    }

    MapButton{
        id: distanceBtn
        anchors.topMargin: 10
        anchors.top: parent.top
        anchors.horizontalCenter: parent.horizontalCenter
        btnVisible: false
        buttonText: "Distance"
        onButtonClicked: {
            //mapView.center = stationPosition;
            var distanceVal = Util.distance( stationPosition.latitude , stationPosition.longitude , myPositionSource.position.coordinate.latitude , myPositionSource.position.coordinate.longitude )
            //var bearingVal = Util.bearingP1toP2( myPositionSource.position.coordinate.latitude , myPositionSource.position.coordinate.longitude , stationPosition.latitude , stationPosition.longitude  )
            dialog.text = "Distance is : " + Util.distanceFormat(distanceVal) + " left";
            dialog.show();

            Util.log("Distance = " + distanceVal)
        }
    }


    MapButton{
        id: stationBtn
        anchors.topMargin: 10
        anchors.top: parent.top
        anchors.left: parent.left

        buttonText: "Station"
        onButtonClicked: {
            mapView.center = stationPosition;            
        }
    }

    Item{
        id: sliderContainer
        anchors.bottom: parent.bottom
        height: 50
        width: parent.width

        Slider{
            id: zoomSlider
            minimum: 1 ; maximum: 18
            value: 15
            height: 80
            anchors.left: parent.left
            anchors.right: parent.right
            anchors.bottomMargin: 5; anchors.rightMargin: 20; anchors.leftMargin: 20

            onValueChanged: {
                console.log("Zoom slider value changed to: " + value)
                mapView.zoomLevel = value
            }

        }
    }

    ModalDialog {
        id: dialog

        // Shown text can be set by modifying "text" property.
        text: "Now waiting Location Information\nPlease try again later!"
        // Always remember to define the size for the dialog.
        anchors.fill: parent

        // Demonstrating how one could keep application wide variables saved
        // in one place and use them conveniently all around the application.
        fontName: visual.defaultFontFamily
        fontColor: "white"
        fontColorButton: "Black"
        fontSize: 18
        showCancelButton : false
        // Use these if you would like to change the Button look and feel.
        // See Visual.qml how these are defined. Remember to modify also the
        // ModalDialog.qml, since this functionality is disabled currently.
        //        buttonBackground: visual.buttonComponent
        //        buttonBackgroundPressed: visual.buttonPressedComponent

        onAccepted: {
            // When dialog is accepted, e.g. the data model could be updated.
            // Just debug print here to show how to use the ModalDialog signals.
            console.log("Dialog accepted signal received!");
        }
        onCancelled: {
            console.log("Dialog cancelled signal received.")
        }
    }

}
