import QtQuick 1.0
import "./js/Util.js" as Util

XmlListModel {
    id: model
    property string  railId: ""

    source: "content/info.xml"    
    query: "/stations/railroad[@id='" + railId +  "']/station"

    XmlRole { name: "name"; query: "@name/string()" }
    XmlRole { name: "cateId"; query: "@cateid/string()" }
    XmlRole { name: "latitude" ; query:  "coordinates/latitude/string()"}
    XmlRole { name: "longitude" ; query:  "coordinates/longitude/string()"}
    XmlRole { name: "stationDesc" ; query:  "desc/string()"}
    XmlRole { name: "stationDesc2" ; query:  "tranlink/string()"}
//    <station name="Baclaran">
//        <coordinates>
//           <latitude>14.534354</latitude>
//            <longitude>120.998341</longitude>
//        </coordinates>
//    <desc>The station is located on the last stretches of Taft Avenue, in the Pasay City portion of Baclaran, and, like all other stations on the LRT-1, Baclaran station is above-ground on viaduct. The station is named after the famous shopping district of the same name.</desc>

    onStatusChanged: {
        if (status == XmlListModel.Ready) {
            Util.log("SationModel Status: ready Count:" + model.count + " Raid Id=" + model.railId )
        } else if (status == XmlListModel.Error) {
            Util.log("SationModel Status: error")
        } else if (status == XmlListModel.Loading) {
            Util.log("SationModel Status: loading")            
        }
    }
}
