import QtQuick 1.0

Item{
    // General
    property string defaultFontFamily: "Helvetica"
    property int  defaultFontSize: 18

    // Main window
    property color applicationBackgroundColor: "white"


    // Splash screen time
    property int splashTimeout: 2500

    property int defaultMargins : 8


    // Title Bar
    property color  titleBarFontColor : "black"
    property color  titleBarBackgroundColor: "lightgrey"
    property color  titleBarCaptionFontColor: "black"
    property color  titleBarcaptionBackgroundColor: "white"



    //property color defaultFontColor: "#6f6a5c"
    property color defaultFontColor: "#767164"
    property color  defaultFontColorLink: "#7C0505"
    property color  defaultFontColorButton: "#ffffff"
    property color  defaultBackgroundColor: "#d9d3b5"
    property double  margins: 4
    property int  spacing: 8
    property int  defaultItemHeight: 48

    property int  scrollBarWidth: 8

    property Component buttonComponent: Component{
        BorderImage {
            source: "./content/button.png"
            border.left: 8; border.top: 8
            border.right: 8; border.bottom: 8
        }
    }
    property Component buttonPressedComponent: Component{
        BorderImage {
            source: "./content/button_pressed.png"
            border.left: 8; border.top: 8
            border.right: 8; border.bottom: 8
        }
    }

    property Component textFieldComponent: Component{
        BorderImage {
            source: "./content/text_field.png"
            border.left: 8; border.top: 8
            border.right: 8; border.bottom: 8
        }
    }

    property Component textFieldActiveComponent: Component{
        BorderImage {
            source: "./content/text_field_active.png"
            border.left: 8; border.top: 8
            border.right: 8; border.bottom: 8
        }
    }

    // For TitleBar
    property string titleImageSource: "./gfx/title2.png"
    property string exitButtonSource: "./gfx/exit_button.png"
    property string exitButtonPressedSource: "./gfx/exit_button_pressed.png"
    property string backButtonSource: "./gfx/back_button.png"
    property string backButtonPresseSource: "./gfx/back_button_pressed.png"


    property string callButtonSource: "./content/call_button.png"
    property string callButtonPressedSource: "./content/call_button_pressed.png"
    property string wwwButtonSource: "./content/www_button.png"
    property string wwwButtonPressedSource: "./content/www_button_pressed.png"

    property string cancelButtonSource: "./content/cancel_button.png"
    property string cancelButtonPressedSource: "./content/cancel_button.png"
    property string bookingIconSource: "./content/booking_icon.png"

    //Title bar
    property int  titleFontSize: 36
    property color  titleFontColor: "#ffffff"
    property color titleBackgroundColor: "#C42929"

    property string captionFontFamily: defaultFontFamily
    property int  captionFontSize: 10
    property color  captionFontColor: "#333333"
    property color  captionBackgroundColor: "#f2f2f2"



    //Tab bar
    property string tabBarButtonFont: defaultFontFamily
    property int  tabBarButtonFontSize: 12
    property color  tabBarButtonFontColor: "#ffffff"

    property string  basicInfoButtonSource: "./content/home.png"
    property string  lrt1InfoButtonSource: "./content/lrt1.png"
    property string  lrt2InfoButtonSource: "./content/lrt2.png"
    property string  mrtInfoButtonSource: "./content/mrt3.png"
    property string myLocationButtonSource: "./content/nearby.png"

    property string  basicInfoButtonPressedSource: "./content/homeSelected.png"
    property string  lrt1InfoButtonPressedSource: "./content/lrt1Selected.png"
    property string  lrt2InfoButtonPressedSource: "./content/lrt2Selected.png"
    property string  mrtInfoButtonPressedSource: "./content/mrt3Selected.png"
    property string myLocationButtonPressedSource: "./content/nearbySelected.png"


    //-----------------------------------------------------------------------------------------------------------------
    // Basi  Info View
    property int  basicInfoViewReservationFontSize: 14
    property int  basicInfoViewAddressFontSize: 16
    property int  basicInfoViewFontSize: 16
    property int  basicInfoViewTitleFontSize: 17
    property color  basicInfoViewTitleFontColor : "#696969"


    // LRT1 , LRT2 , MRT3 Color
    property color  lrt1TitleColor: "#FF8C00"
    property color  lrt2TitleColor: "#8A2BE2"
    property color  mrt3TitleColor: "#4682B4"

    // Menu grid view
    property int  menuGridViewFontSize: 16



    // Station Info View
    property color  stationInfoViewBackground : "#ffffe0"

//    property int fontSizeTitle: visual.menuListViewTitleSize
//    property color fontColor: visual.menuListViewDishFontColor
//    property color fontColorTitle: visual.menuListViewDishTitleFontColor

    //property color  DishTitleFontColor: "#7c0505"
    property color  stationInfoViewDescFontColor: "#938282"
    property int  stationInfoViewTitleSize: 12
    property int  stationInfoViewDescFontSize: 10

    // Map View
    property string zoomInSurce: "./content/zoom_in.png"
    property string zoomOutSource: "./content/zoom_out.png"
    property int  infoFontSize: 8

    // Booking View
}
