.pragma library

var LOGGING_TAG = "MRL"

function log(message) {
    console.log("[" + LOGGING_TAG + "] " + message);
}

function exitApp(message) {
    if (message) {
        log("Exiting app: " + message);
    } else {
        log("Exiting app")
    }
    Qt.quit();
}

function distance( P1_lat , P1_long , P2_lat , P2_long )
{
    if(( P1_lat == P2_lat) && (P1_long == P2_long ))
    {
        return 0;
    }

    var e10 = P1_lat * Math.PI / 180;
    var e11 = P1_long * Math.PI / 180;
    var e12 = P2_lat * Math.PI / 180;
    var e13 = P2_long * Math.PI / 180;


    /* GRS80 */
    var c16 = 6356752.314140910;
    var c15 = 6378137.000000000;
    var c17 =  0.0033528107;

    var f15 =  c17 + c17 * c17;
    var f16 = f15 / 2;
    var f17 = c17 * c17 / 2;
    var f18 = c17 * c17 / 8;
    var f19 = c17 * c17 / 16;

    log(f15 + "-" + f16 + "-" + f17 + "-" +  f18 + "-" + f19  )
    //   return P1_lat;

    var c18 = e13 - e11;
    var c20 = (1 - c17) * Math.tan(e10);
    var c21 = Math.atan(c20)
    var c22 = Math.sin(c21);
    var c23 = Math.cos(c21);
    var c24 = (1 - c17) * Math.tan(e12);
    var c25 = c25 = Math.atan(c24);
    var c26 = c26 = Math.sin(c25);
    var c27 = Math.cos(c25);

    var c29 = c18;
    var c31 = (c27 * Math.sin(c29) * c27 * Math.sin(c29)) + (c23 * c26 - c22 * c27 * Math.cos(c29)) * (c23 * c26 - c22 * c27 * Math.cos(c29));
    var c33 = (c22 * c26) + (c23 * c27 * Math.cos(c29));
    var c35 = Math.sqrt(c31) / c33;
    var c36 = Math.atan(c35);
    var c38 = 0;

    if (c31 === 0)
    {
        c38 = 0;
    }else{
        c38 = c23 * c27 * Math.sin(c29) / Math.sqrt(c31);
    }

    var c40 = 0.0;
    if ((Math.cos(Math.asin(c38)) * Math.cos(Math.asin(c38))) === 0)
    {
        c40 = 0;
    }else{
        c40 = c33 - 2 * c22 * c26 / (Math.cos(Math.asin(c38)) * Math.cos(Math.asin(c38)));
    }

    var c41 = Math.cos(Math.asin(c38)) * Math.cos(Math.asin(c38)) * (c15 * c15 - c16 * c16) / (c16 * c16);
    var c43 = 1 + c41 / 16384 * (4096 + c41 * (-768 + c41 * (320 - 175 * c41)));
    var c45 = c41 / 1024 * (256 + c41 * (-128 + c41 * (74 - 47 * c41)));
    var c47 = c45 * Math.sqrt(c31) * (c40 + c45 / 4 * (c33 * (-1 + 2 * c40 * c40) - c45 / 6 * c40 * (-3 + 4 * c31) * (-3 + 4 * c40 * c40)));
    var c50 = c17 / 16 * Math.cos(Math.asin(c38)) * Math.cos(Math.asin(c38)) * (4 + c17 * (4 - 3 * Math.cos(Math.asin(c38)) * Math.cos(Math.asin(c38))));
    var c52 = c18 + (1 - c50) * c17 * c38 * (Math.acos(c33) + c50 * Math.sin(Math.acos(c33)) * (c40 + c50 * c33 * (-1 + 2 * c40 * c40)));

    var c54 = c16 * c43 * (Math.atan(c35) - c47);

    // return distance in meter
    //log( c54 );
    return c54;
}

function distanceFormat( dblDistance )
{
    var intDistance = parseInt(dblDistance);
    var r1 , r2 ;

    if( intDistance >= 1000 )
    {
        r1 = intDistance / 1000;
        r2 = intDistance % 1000;
        log("Distance = " + intDistance +" R1 = " + r1 + "   R2 = " + r2 )
        return parseInt(r1) + "K " + r2 + "m" ;
    }else{
        return intDistance + "m"
    }


}

function bearingP1toP2( P1_latitude,  P1_longitude,  P2_latitude,  P2_longitude)
{
    // 현재 위치 : 위도나 경도는 지구 중심을 기반으로 하는 각도이기 때문에 라디안 각도로 변환한다.
    var Cur_Lat_radian = P1_latitude * (3.141592 / 180);
    var Cur_Lon_radian = P1_longitude * (3.141592 / 180);


    // 목표 위치 : 위도나 경도는 지구 중심을 기반으로 하는 각도이기 때문에 라디안 각도로 변환한다.
    var Dest_Lat_radian = P2_latitude * (3.141592 / 180);
    var Dest_Lon_radian = P2_longitude * (3.141592 / 180);

    // radian distance
    var radian_distance = 0;
    radian_distance = Math.acos(Math.sin(Cur_Lat_radian) * Math.sin(Dest_Lat_radian) + Math.cos(Cur_Lat_radian) * Math.cos(Dest_Lat_radian) * Math.cos(Cur_Lon_radian - Dest_Lon_radian));

    // 목적지 이동 방향을 구한다.(현재 좌표에서 다음 좌표로 이동하기 위해서는 방향을 설정해야 한다. 라디안값이다.
    var radian_bearing = Math.acos((Math.sin(Dest_Lat_radian) - Math.sin(Cur_Lat_radian) * Math.cos(radian_distance)) / (Math.cos(Cur_Lat_radian) * Math.sin(radian_distance)));
    // acos의 인수로 주어지는 x는 360분법의 각도가 아닌 radian(호도)값이다.

    var true_bearing = 0;
    if (Math.sin(Dest_Lon_radian - Cur_Lon_radian) < 0)
    {
        true_bearing = radian_bearing * (180 / 3.141592);
        true_bearing = 360 - true_bearing;
    }
    else
    {
        true_bearing = radian_bearing * (180 / 3.141592);
    }

    return parseInt(true_bearing);
}

